<?php
namespace App\Utils;

use DOMDocument;

class TypesTransformer {
    // json converter
    public function arrayToXml($array, &$xml){
        foreach ($array as $key => $value) {
            if(is_int($key)){
                $key = "e";
            }
            if(is_array($value)){
                $label = $xml->addChild($key);
                $this->arrayToXml($value, $label);
            }
            else {
                $xml->addChild($key, $value);
            }
        }
    }

    // csv converter
    function convertCsvToXmlString($csv_string) {
        $lines = explode(PHP_EOL, $csv_string);
        $headers = explode(',', array_shift($lines));

        $doc  = new DomDocument();
        $doc->formatOutput   = true;

        $root = $doc->createElement('products');
        $root = $doc->appendChild($root);
        foreach ($lines as $line)
        {
            $row = str_getcsv($line);
            $container = $doc->createElement('product');
            foreach($headers as $i => $header)
            {
                $child = $doc->createElement($header);
                $child = $container->appendChild($child);
                $value = $doc->createTextNode($row[$i]);
                $value = $child->appendChild($value);
            }
            $root->appendChild($container);
        }

        return $doc->saveXML();
    }
}
